/**
 *    author:  [itmo] enot.1.10
 *    created: 28.01.2017 01:20:25       
**/
#define __USE_MINGW_ANSI_STDIO 0
#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define forn(i, n) for(int i = 0 ; (i) < (n) ; ++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__),fflush(stderr)
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(),a.end()
#define pw(x) (1LL<<(x))

using namespace std;

typedef long long ll;
typedef double dbl;
typedef vector<int> vi;
typedef pair<int, int> pi;

const int inf = 1.01e9;
const dbl eps = 1e-9;

/* --- main part --- */

const int N = 2e5 + 10;

#define next fucknext
int head[N], next[N], to[N], ec = 1;

void add(int x, int y)
{
    ec++;
    to[ec] = y;
    next[ec] = head[x];
    head[x] = ec;
}

int l[N], r[N];
int L[N], R[N];

void dfs0(int x, int ee)
{
    L[ee] = 0;
    R[ee] = inf;
    for (int e = head[x]; e; e = next[e]) if ((e ^ ee) != 1)
    {
        dfs0(to[e], e);
        L[ee] = max(L[ee], L[e]);
        R[ee] = min(R[ee], R[e]);
    }
    if (L[ee] > R[ee])
    {
        L[ee] = inf;
        R[ee] = 0;
    }
    if (R[ee] == inf)
    {
        R[ee] = 0;
    }
    L[ee] += l[x];
    R[ee] += r[x];
        
    eprintf("to %d --> %d %d\n", x + 1, L[ee], R[ee]);
}

int res[N];

void dfs1(int x, int ee)
{
    vi sons;
    for (int e = head[x]; e; e = next[e]) if ((e ^ ee) != 1) sons.pb(e);
    int SZ = sz(sons);
    vi pl(SZ + 1), pr(SZ + 1), sl(SZ + 1), sr(SZ + 1);
    
    for (int i = 0; i < SZ; ++i) pl[i + 1] = max(pl[i], L[sons[i]]);
    for (int i = SZ - 1; i >= 0; --i) sl[i] = max(sl[i + 1], L[sons[i]]);

    pr[0] = sr[SZ] = inf;
    for (int i = 0; i < SZ; ++i) pr[i + 1] = min(pr[i], R[sons[i]]);
    for (int i = SZ - 1; i >= 0; --i) sr[i] = min(sr[i + 1], R[sons[i]]);

    for (int i = 0; i < SZ; ++i)
    {
        int e = sons[i] ^ 1;
        L[e] = max(L[ee ^ 1], max(pl[i], sl[i + 1]));
        R[e] = min(R[ee ^ 1], min(pr[i], sr[i + 1]));
        if (L[e] > R[e])
        {
            L[e] = inf;
            R[e] = 0;
        }
        else
        {
            L[e] += l[x];
            R[e] += r[x];
        }
    }

    for (int i = 0; i < SZ; ++i) dfs1(to[sons[i]], sons[i]);


    int GL = max(L[ee ^ 1], pl[SZ]);
    int GR = min(R[ee ^ 1], pr[SZ]);
    
    res[x] = GL <= GR;
}



int main()
{
    assert(freopen("lamps.in", "r", stdin));
    assert(freopen("lamps.out", "w", stdout));
    int n;
    scanf("%d", &n);
    forn(i, n - 1)
    {
        int x, y;
        scanf("%d%d", &x, &y);
        --x, --y;
        add(x, y);
        add(y, x);
    }
    forn(i, n) scanf("%d%d", &l[i], &r[i]);
    L[1] = 0, R[1] = inf;
    dfs0(0, 0);
    dfs1(0, 0);

    forn(i, n) printf("%d%c", res[i], " \n"[i + 1 == n]);

        
    #ifdef home
        eprintf("time = %d ms\n", (int)(clock() * 1000. / CLOCKS_PER_SEC));
    #endif
    return 0;
}
